import { Component, ChangeDetectionStrategy, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FieldWrapper, FormlyModule } from '@ngx-formly/core';
import { ReactiveFormsModule } from '@angular/forms';

class FormlyWrapperAddons extends FieldWrapper {
    addonRightClick($event) {
        var _a, _b;
        (_b = (_a = this.to.addonRight).onClick) === null || _b === void 0 ? void 0 : _b.call(_a, this.to, this, $event);
    }
    addonLeftClick($event) {
        var _a, _b;
        (_b = (_a = this.to.addonLeft).onClick) === null || _b === void 0 ? void 0 : _b.call(_a, this.to, this, $event);
    }
}
FormlyWrapperAddons.decorators = [
    { type: Component, args: [{
                selector: 'formly-wrapper-addons',
                template: "<div class=\"input-group\">\n  <div\n    class=\"input-group-prepend\"\n    *ngIf=\"to.addonLeft\"\n    [ngStyle]=\"{ cursor: to.addonLeft.onClick ? 'pointer' : 'inherit' }\"\n    (click)=\"addonLeftClick($event)\"\n  >\n    <i class=\"input-group-text\" [ngClass]=\"to.addonLeft.class\" *ngIf=\"to.addonLeft.class\"></i>\n    <span *ngIf=\"to.addonLeft.text\" class=\"input-group-text\">{{ to.addonLeft.text }}</span>\n  </div>\n  <div class=\"input-addons\">\n    <ng-container #fieldComponent></ng-container>\n  </div>\n  <div\n    class=\"input-group-append\"\n    *ngIf=\"to.addonRight\"\n    [ngStyle]=\"{ cursor: to.addonRight.onClick ? 'pointer' : 'inherit' }\"\n    (click)=\"addonRightClick($event)\"\n  >\n    <i class=\"input-group-text\" [ngClass]=\"to.addonRight.class\" *ngIf=\"to.addonRight.class\"></i>\n    <span *ngIf=\"to.addonRight.text\" class=\"input-group-text\">{{ to.addonRight.text }}</span>\n  </div>\n</div>\n",
                changeDetection: ChangeDetectionStrategy.OnPush,
                styles: [":host ::ng-deep .input-group>:not(:first-child) .form-control{border-top-left-radius:0;border-bottom-left-radius:0}:host ::ng-deep .input-group>:not(:last-child) .form-control{border-top-right-radius:0;border-bottom-right-radius:0}:host ::ng-deep .input-group>.input-addons{position:relative;flex:1 1 auto;width:1%;margin-bottom:0}"]
            },] }
];

function addonsExtension(field) {
    if (!field.templateOptions || (field.wrappers && field.wrappers.indexOf('addons') !== -1)) {
        return;
    }
    if (field.templateOptions.addonLeft || field.templateOptions.addonRight) {
        field.wrappers = [...(field.wrappers || []), 'addons'];
    }
}

class FormlyBootstrapAddonsModule {
}
FormlyBootstrapAddonsModule.decorators = [
    { type: NgModule, args: [{
                declarations: [FormlyWrapperAddons],
                imports: [
                    CommonModule,
                    ReactiveFormsModule,
                    FormlyModule.forChild({
                        wrappers: [{ name: 'addons', component: FormlyWrapperAddons }],
                        extensions: [{ name: 'addons', extension: { postPopulate: addonsExtension } }],
                    }),
                ],
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { FormlyBootstrapAddonsModule, FormlyWrapperAddons as ɵa, addonsExtension as ɵb };
//# sourceMappingURL=ngx-formly-bootstrap-addons.js.map
